;//**   File: gfgetline.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat, stdcall
option casemap: none

ReadFile proto :dword, :dword, :dword, :dword, :dword


.code

;=====================================================================
;   int stdcall gfGetLine (HANDLE hFile, char* pcDest, char cDelim)
;=====================================================================
gFGetLine proc hFile:dword, pcDest:dword, cDelim:byte
	;/------------------------------------------------------------------------\
	;| Gets bytes from file until found cDelim char and puts it in the pcDest |
	;| Returns the bytes read                                                 |
	;| Build for compact code                                                 |
	;\------------------------------------------------------------------------/
	local bytesRead:dword
	local temp:dword 
	local cTemp:word
	push ebx
	
	;bytesRead = 0;
	mov dword ptr [bytesRead], 00h
		
	;while ( ReadFile(hFile, &cTemp, 1, &temp, NULL) && cTemp!=cDelim && temp==1 ) {
	gFGetLine_0_while:
	invoke ReadFile, hFile, addr cTemp, 1, addr temp, 00h
	test eax, eax
	je gFGetLine_0_endw
	cmp dword ptr [temp], 01h
	jne gFGetLine_0_endw
	mov al, byte ptr [cDelim]
	cmp byte ptr [cTemp], al
	je gFGetLine_0_endw
		.if cTemp != 0Dh
			;++bytesRead;
			inc dword ptr [bytesRead]
			;*pcDest++ = cTemp;
			mov bl, byte ptr [cTemp]
			mov eax, dword ptr [pcDest]
			mov byte ptr [eax], bl
			inc dword ptr [pcDest]
		.endif
	;} //while
	jmp gFGetLine_0_while
	gFGetLine_0_endw:
	
	.if bytesRead != 0
		;++ bytesRead;
		inc dword ptr [bytesRead]
		;*pcDest = '\0';
		mov eax, dword ptr [pcDest]
		mov byte ptr [eax], 00h
	.endif
	
	;return bytesRead;
	mov eax, dword ptr [bytesRead]
	pop ebx
	ret
gFGetLine endp



end