;//**   File: guinttostr.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat, stdcall
option casemap: none

gStrcpy proto :dword, :dword
		
.code

;=====================================================
;   void stdcall gUIntToStr (char* pcDest, int num)
;=====================================================
OPTION EPILOGUE:NONE
gUIntToStr proc pcDest:dword, num:dword
	;/-------------------------------------------------------------------------------\
	;| UNSIGNED int to string convertion                                             |
	;| Make sure that the pcDest is big enought to fit the string (at least 11bytes) |
	;| Returns the bytes written munus one                                           |
	;\-------------------------------------------------------------------------------/
	local pcTmp[12]:byte          ;a temp string
	push ebx                      ;used only in div
	push edi                      ;the pointer to the returned str
	push edx                      ;used only in div
	
	lea edi, pcTmp+11             ;edi = &pcTmp[11]
	mov byte ptr [edi], 00h       ;finalize string
	
	mov eax, dword ptr [num]      ;eax = num
		
	;----------------
	;Build the string
	;----------------
	mov ebx, 10
	@@:
		xor edx, edx	
		div ebx

		add dl, '0'                 ;dl is equal to the div's remainder

		dec edi
		mov byte ptr [edi], dl

	test eax, eax                 ;do while eax!=0
	jne @B

	;----------------------------------------
	;now copy the temp string to the dest str
	;----------------------------------------
	invoke gStrcpy, pcDest, edi
	
	pop edx
	pop edi
	pop ebx
	mov esp, ebp
	pop ebp
	ret 08h
gUIntToStr endp
OPTION EPILOGUE:EpilogueDef

	
end