//**   File: glib.h
//**
//**   Created by GODlike (www.ancientritual.tk)


#ifndef _GLIB_H_INCLUDED_
#define _GLIB_H_INCLUDED_

#ifndef _WINDOWS_                           
#include <windows.h>                      
#endif

#ifdef __cplusplus
extern "C" {
#endif

//string funcs
int    _stdcall gStrlen      (char* pc);
int    _stdcall gStrcpy      (char* dest, char* src);
int    _stdcall gStrcat      (char* dest, char* src);

//misc funcs
void   _stdcall gMemcopy     (void* dest, void* src, int size);
void   _cdecl   gPrintf      (char* pcFormat, ...);
int    _stdcall gStdOut      (char* pc);
int    _stdcall gStdIn       (char* pc);
int    _stdcall gfGetLine    (HANDLE hFile, char* pcDest, char cDelim);

//convertions funcs
int    _stdcall gIntToStr    (char* pcDest, int num);
int    _stdcall gUIntToStr   (char* pcDest, int num);
int    _stdcall gIntToStrHex (char* pcDest, int num);
int    _stdcall gDoubleToStr (char* pcDest, double dbl);

int    _stdcall gStrToInt    (char* str);
int    _stdcall gStrToIntHex (char* str);
double _stdcall gStrToDouble (char* str);



#ifdef __cplusplus
}
#endif

#endif