;//**   File: ginttostr.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat, stdcall
option casemap: none

gStrcpy proto :dword, :dword
		
.code

;====================================================
;   void stdcall gIntToStr (char* pcDest, int num)
;====================================================
OPTION EPILOGUE:NONE
gIntToStr proc pcDest:dword, num:dword
	;/-------------------------------------------------------------------------------\
	;| SIGNED int to string convertion                                               |
	;| Make sure that the pcDest is big enought to fit the string (at least 11bytes) |
	;| Returns the bytes written munus one                                           |
	;\-------------------------------------------------------------------------------/
	local bSign:byte              ;for sign. 00 if >=0 or '-' if <0
	local pcTmp[12]:byte          ;a temp string
	push ebx                      ;used only in div
	push edi                      ;the pointer to the returned str
	push edx                      ;used only in div
	
	mov bSign, 00h
	lea edi, pcTmp+11             ;edi points to the penult
	mov byte ptr [edi], 00h       ;finalize string
	
	
	;-----------------------------------------------
	;Check the num's sign, set the bSign and neg eax
	;-----------------------------------------------
	mov eax, dword ptr [num]      ;eax = num
	test eax, eax                 ;check if eax < 0
	jge @F
		mov byte ptr [bSign], '-'   ;bSign = 01h
		neg eax                     ;eax = -eax;
	@@:
	
	;----------------
	;Build the string
	;----------------
	mov ebx, 10
	@@:
		xor edx, edx	
		div ebx

		add dl, '0'                 ;dl is equal to the div's remainder

		dec edi
		mov byte ptr [edi], dl

	test eax, eax                 ;do while eax!=0
	jne @B

	;--------------------------------------
	;Set the '-' in the string if necessary
	;--------------------------------------
	mov al, byte ptr [bSign]
	test al, al
	je @F	
		dec edi
		mov byte ptr [edi], al
	@@:	

	;----------------------------------------
	;now copy the temp string to the dest str
	;----------------------------------------
	invoke gStrcpy, pcDest, edi
	
	pop edx
	pop edi
	pop ebx
	mov esp, ebp
	pop ebp
	ret 08h
gIntToStr endp
OPTION EPILOGUE:EpilogueDef

	
end