;//**   File: gstdout.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat, stdcall
option casemap: none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc

.code

;====================================
;   int stdcall gStdOut (char* pc)  
;====================================
gStdOut proc pc:dword
	;/--------------------------------------\
	;| Prints the pc string to console      |
	;| Returns the bytes printed in console |
	;\--------------------------------------/
	local temp:dword
	push edi
	push ecx
	push edx                    ;because WriteFile changes ecx and edx without restoring them
	
	;---------------
	;get pc's length
	;---------------
	mov edi, dword ptr [pc]
	xor eax, eax
	or ecx, 0FFFFFFFFh
	repne scas byte ptr [edi]
	not ecx
	dec ecx
	
	;----------------------
	;get console out handle
	;----------------------
	invoke GetStdHandle, STD_OUTPUT_HANDLE
	mov edi, eax
	
	;---------------------------------
	;call the Win32 api func WriteFile
	;---------------------------------
	invoke WriteFile, edi, pc, ecx, ADDR temp, NULL 
	
	mov eax, temp
	
	pop edx
	pop ecx
	pop edi
	ret
gStdOut endp
	

end