;//**   File: gprintf.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686           
.model  flat, stdcall  
option casemap: none
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
gStrcpy       proto stdcall :dword, :dword
gIntToStr     proto stdcall :dword, :dword
gIntToStrHex  proto stdcall :dword, :dword
gDoubleToStr  proto stdcall :dword, :qword
WriteFile     proto stdcall :dword, :dword, :dword, :dword, :dword
GetStdHandle  proto stdcall :dword
SzCpy7        proto :DWORD, :DWORD
STD_OUTPUT_HANDLE equ -11


.code
;========================================
;   void gPrintf (char* pcFormat, ...)
;========================================
OPTION EPILOGUE:NONE
xPrintf proc C pcFormat:dword, param0:dword
	local pcTmp[400]:byte
	local tmp:dword
	;/-------------------------------------------\
	;| A func just like printf                   |
	;| Format: %i: integer                       |
	;|         %x: integer in hexademical format |
	;|         %c: char                          |
	;|         %s: string                        |
	;|         %e: double floating point number  |
	;\-------------------------------------------/
	local handle:dword
	push edx
	push esi
	push ecx
	
	lea edx, pcTmp 
	
	mov esi, pcFormat
	lea ecx, param0
	
	mov al, byte ptr [esi]
	inc esi ;seems to be faster to leave this one as inc rather than add
	;-------------
	;the main loop
	;-------------
	@@:
	.if al == '%'

		mov al, byte ptr [esi]
		add esi,1
		;inc esi		
		cmp al, 's'
		je case_s
		cmp al, 'i'
		je case_i
		cmp al, 'x'
		je case_x
		cmp al, 'e'
		je case_e
		cmp al, 'c'
		je case_c
		jmp default	
		
		
		case_s:
			invoke SzCpy7, edx, dword ptr [ecx]
			add edx, eax
			add ecx, 04h
			jmp case_break
		case_i:
			invoke gIntToStr, edx, dword ptr [ecx]
			add edx, eax
			add ecx, 04h
			jmp case_break
		case_x:
			invoke gIntToStrHex, edx, dword ptr [ecx]
			add edx, eax
			add ecx, 04h
			jmp case_break
		case_e:
			invoke gDoubleToStr, edx, qword ptr [ecx]
			add edx, eax
			add ecx, 08h
			jmp case_break
		case_c:
			mov al, byte ptr [ecx]
			add ecx, 04h
		default:
			mov byte ptr [edx], al
			;inc edx
			add edx,1
		case_break:
	.else
		mov byte ptr [edx], al
		add edx,2
	.endif
	mov al, byte ptr [esi]
	;inc esi
	add esi,1
	test al, al
	jne @B
	
	;----------------
	;print the string
	;----------------
	lea eax, pcTmp
	sub edx, eax                               ;edx has the string's length
	invoke GetStdHandle, STD_OUTPUT_HANDLE     ;get console output handle
	
	
	mov ecx, eax
	invoke WriteFile, ecx, addr pcTmp, edx, ADDR tmp, 00h 
	
	pop ecx
	pop esi
	pop edx
	mov esp, ebp
	pop ebp
	ret
xPrintf endp
OPTION EPILOGUE:EpilogueDef

;by Lingo
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE 
align 16
db 90h,90h,90h
SzCpy7   proc    SzDest:DWORD, SzSource:DWORD
    mov ecx, [esp+8]    ; ecx = source
    mov edx, [esp+4]    ;  edx= destination
    push ebx
    xor eax, eax
    mov bl, [ecx]       ; read byte
 @@:     
    add [edx+eax], bl   ; write byte
    lea	eax, [eax+1]
    mov bl, [ecx+eax]   ; read byte
    jnz  @B             ; keep going
    pop ebx
    ret	2*4
SzCpy7 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef


end